/*===========================================================================*/
/*
 * This file is part of libpersist - a c++ library for object persistence
 *
 * Copyright (C) 2006  Elaine Tsiang YueLien
 *
 * libpersist is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to
 * Free Software Foundation, Inc.
 * 51 Franklin Street, Fifth Floor
 * Boston, MA  02110-1301, USA
 *
 *===========================================================================*/
/*                                                                           */
/* Persistence::Status implementation                                        */
/*                                                                           */
/*===========================================================================*/
#ifdef __GNUG__
#pragma implementation
#endif

#include	<persist/Basic.H>

namespace Persistence
{
  using std::ostringstream;
  using std::ostream;

  Status&
  Status::operator=(const Status & s)
  {
    return_ = s.return_;
    os().str() = const_cast<Status &>(s).os().str();
    return(*this);
  }
  
  Status&
  Status::operator&=(const Status & s)
  {
    // fuzzy intersect
    return_ = ((s.return_ < return_)?
	       s.return_
	       :return_
	       );
    // concatenate text
    os() << s.what();
    return(*this);
  }

}

