/*===========================================================================*/
/*
 * This file is part of libpersist - a c++ library for object persistence
 *
 * Copyright (C) 2006  Elaine Tsiang YueLien
 *
 * libpersist is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to
 * Free Software Foundation, Inc.
 * 51 Franklin Street, Fifth Floor
 * Boston, MA  02110-1301, USA
 *
 *===========================================================================*/
/*                                                                           */
/* Persistence::DtorCommand class interface                                  */
/*                                                                           */
/*===========================================================================*/
#ifndef	PersistDtorCommand
#define	PersistDtorCommand


#include	<persist/Basic.H>


namespace	Persistence
{
  class DtorCommand
  {
  public:
    enum Command
      {
	DELETE	= 0,
	DEL	= 1,
	PUT	= 2,
	RELOCATE= 3,
	SWIZZLE = 4
      };

  protected:
    Status	sta;
    int		com;		// so that user can define own enum command type

  public:
    DtorCommand()
      : sta()
	,com(DELETE)
    {}

    virtual
    ~DtorCommand()
    {}

    Status	dtorStatus() throw()
    {
      return(sta);
    }

    int		dtorCommand() throw()
    {
      return(com);
    }

    void	setDtorStatus(
			      Status	st
			      ) throw()
    {
      sta = st;
    }
    
    void 	setDtorCommand(
			       int	c
			       ) throw()
    {
      com = c;
    }

    void 	resetDtorCommand() throw()
    {
      com = int(DELETE);
    }

  }
  ;
}
#endif
