/*===========================================================================*/
/*
 * This file is part of libpersist - a c++ library for object persistence
 *
 * Copyright (C) 2006  Elaine Tsiang YueLien
 *
 * libpersist is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to
 * Free Software Foundation, Inc.
 * 51 Franklin Street, Fifth Floor
 * Boston, MA  02110-1301, USA
 *
 *===========================================================================*/
/*                                                                           */
/* Persistence:: get, put, del template function declarations                */
/*                                                                           */
/*===========================================================================*/
#ifndef PersistGetPutDel
#define	PersistGetPutDel

#include	<persist/Object.H>

namespace Persistence
{
  template<class T>
  T *	reconstruct(
		    Obj * 	obj
		    );

  template<class T>
  T *		get(
		    const char *	name
		    );

  template<class T> 
  T *		get(
		    const Id	id
		    );
  template<class T>
  Status	put(
		    T &
		    );
  template<class T>
  Status	del(
		    T &
		    );
  template<class T>
  T *		first();

  template<class T>
  T *		next(
		     const T *
		     );
}

#endif
